/** @file HL_sys_main.c 
*   @brief Application main file
*   @date 11-Dec-2018
*   @version 04.07.01
*
*   This file contains an empty main function,
*   which can be used for the application.
*/

/* 
* Copyright (C) 2009-2018 Texas Instruments Incorporated - www.ti.com  
* 
* 
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*
*    Redistributions of source code must retain the above copyright 
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the 
*    documentation and/or other materials provided with the   
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/


/* USER CODE BEGIN (0) */
/* USER CODE END */

/* Include Files */

#include "HL_sys_common.h"

/* USER CODE BEGIN (1) */
#include "HL_emac.h"
#include "HL_mdio.h"
#include "HL_hw_reg_access.h"
#include "HL_phy_dp83640.h"
#include "HL_reg_pinmux.h"
#include "HL_pinmux.h"
#include "HL_gio.h"
/* USER CODE END */

/** @fn void main(void)
*   @brief Application main function
*   @note This function is empty by default.
*
*   This function is called after startup.
*   The user can use this function to implement the application.
*/

/* USER CODE BEGIN (2) */

extern hdkif_t hdkif_data[1];
pbuf_t pack[5];
static uint8 data[5][100];
uint32 size1 = 470,size2=94;
uint32 woz[16];
uint32 neo[500];
uint8 emacAddress[6U]   = {0x10U, 0x20U, 0x30U, 0x40U, 0x50U, 0x60U};
uint8 emacdestAddress[6U] = {0xFFU, 0xFFU, 0xFFU, 0xFFU, 0xFFU, 0xFFU};
uint32 emacPhyAddress  = 1U;


void create_packet()
{
    int i,j;
    for(j=0; j<1;j++)                               //Data to be transmitted can be dynamically alloted here//
    {
                       woz[0] = 'N';
                       woz[1] = 'E';
                       woz[2] = 'W';
                       woz[3] = 'P';
                       woz[4] = 'R';
                       woz[5] = 'O';
                       woz[6] = 'D';
                       woz[7] = 'U';
                       woz[8] = 'C';
                       woz[9] = 'T';
                       woz[10]= 'L';
                       woz[11]= 'A';
                       woz[12]= 'U';
                       woz[13]= 'N';
                       woz[14]= 'C';
                       woz[15]= 'H';
    }

    for(i=0;i<5;i++)
    {
    pack[i].tot_len = size1;
    pack[i].len = size2;
    for(j=0;j<6;j++)
    {
        data[i][j] = emacdestAddress[j];       //0xffu;

    }
    for(j=0;j<6;j++)
    {
        data[i][j+6]= emacAddress[j];

    }

    data[i][12] = 0;
    data[i][13] = 80;

    for(j=0;j<16;j++)
    {
        data[i][j+14] = woz[j];    //Data for transfer to be added here //
    }

    pack[i].payload = &data[i][0];
    if(i!=4)
    pack[i].next = &pack[i+1];
    }
    pack[4].next= NULL;
}
/* USER CODE END */


int main(void)
{
/* USER CODE BEGIN (3) */
    while(1)
    {
    _enable_IRQ();
    gioInit();
  //EMAC_lwIP_Main(emacAddress);
    EMACMACSrcAddrSet(EMAC_0_BASE, emacAddress);
    //EMACEnableLoopback(EMAC_0_BASE);
    uint32 sample = EMACHWInit(emacAddress);
    uint32 Test, Alpha,Beta, Kappa,Theta, Gamma, Deca, Hexa, Hepta, Octa, Event, Horizon, String, Theory, Argon, Radon, Space, Curiosity, Perseverance, Falcon, Pixxel;

    create_packet();
    uint32 test = EMACTransmit(&hdkif_data[0], &pack[0]);
    Test  = MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x00, &data);
    Alpha = MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x01, &data);
    Beta  = MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x04, &data);
    Kappa = MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x05, &data);
    Theta = MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x06, &data);
    Gamma = MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x07, &data);
    Deca  = MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x10, &data);
    Hexa  = MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x11, &data);
    Hepta = MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x12, &data);
    Octa  = MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x13, &data);
    Event = MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x15, &data);
    Horizon=MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x16, &data);
    String=MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x17, &data);
    Theory=MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x18, &data);
    Argon =MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x19, &data);
    Radon =MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x1A, &data);
    Space =MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x14, &data);
    Curiosity=MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x1B, &data);
   Perseverance=MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x1C, &data);
   Falcon=MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x1D, &data);
   Pixxel=MDIOPhyRegRead(0xFCF78900, 0x01, (uint32)0x1F, &data);
    //EMACReceive(&hdkif_data);

    size1=600;
    size2=120;
    create_packet();
    EMACTransmit(&hdkif_data[0], &pack[0]);
    //EMACReceive(&hdkif_data);
   }

/* USER CODE END */
}


/* USER CODE BEGIN (4) */
/* USER CODE END */
